#include <bits/stdc++.h>

using namespace std;

int main()
{
    int n,m,q,ai,aj,tren,min1,min2;
    cin>>n>>m;
    int mat[n+5][m+5],odpoc[n][m],odkr[n][m],vred[n][m];
    vector<pair<int,int>> d;
    for(int i=0;i<n;i++)
    {
        for(int j=0;j<m;j++)
        {
            cin>>mat[i][j];
            if(i==0 && j==0) odpoc[i][j]=mat[i][j];

            if(i==0 && j!=0)
            {
                odpoc[i][j]=odpoc[i][j-1]+mat[i][j];
            }
            else if(i!=0 && j==0)
            {
                odpoc[i][j]=odpoc[i-1][j]+mat[i][j];
            }
        }
    }

    for(int i=n-1;i>=0;i--)
    {
        for(int j=m-1;j>=0;j--)
        {
            if(i==n-1 && j==m-1) odkr[i][j]=mat[n-1][m-1];

            if(i==n-1 && j!=m-1)
            {
                odkr[i][j]=odkr[i][j+1]+mat[i][j];
            }
            else if(i!=n-1 && j==m-1)
            {
                odkr[i][j]=odkr[i+1][j]+mat[i][j];
            }
        }
    }

    for(int i=1;i<n;i++)
    {
        for(int j=1;j<m;j++)
        {
            odpoc[i][j]=mat[i][j]+min(odpoc[i][j-1],odpoc[i-1][j]);
        }
    }

    for(int i=n-2;i>=0;i--)
    {
        for(int j=m-2;j>=0;j--)
        {
            odkr[i][j]=mat[i][j]+min(odkr[i][j+1],odkr[i+1][j]);
        }
    }

    for(int i=0;i<n;i++)
    {
        for(int j=0;j<m;j++)
        {
            vred[i][j]=odkr[i][j]+odpoc[i][j]-mat[i][j];
        }
    }

    swap(n,m);
    for(int i=1;i<n;i++)
    {
        min1=INT_MAX;
        min2=INT_MAX;
        if(min2<min1) swap(min1,min2);
        for(int j=0;j<min(i+1,min(n,m));j++)
        {
            tren=vred[j][i-j];
            if(tren<min1)
            {
                min2=min1;
                min1=tren;
            }
            else if(tren<min2)
            {
                min2=tren;
            }
        }
        d.push_back(make_pair(min1,min2));
    }

    for(int i=1;i<m-1;i++)
    {
        min1=INT_MAX;
        min2=INT_MAX;

        if(min2<min1) swap(min1,min2);
        for(int j=0;j<min(m-i,min(n,m));j++)
        {
            tren=vred[i+j][n-j-1];
            if(tren<=min1)
            {
                min2=min1;
                min1=tren;
            }
            else if(tren<min2) min2=tren;
        }
        d.push_back(make_pair(min1,min2));
    }

    cin>>q;
    for(int i=0;i<q;i++)
    {
        cin>>ai>>aj;
        ai-=1;
        aj-=1;
        if(vred[ai][aj]==d[ai+aj-1].first) cout<<d[ai+aj-1].second<<"\n";
        else cout<<d[ai+aj-1].first<<"\n";
    }
    return 0;
}